// cMaHScroll.cpp : implementation file
//

#include "stdafx.h"
#include "cMaHScroll.h"
#include "cube.h"
#include "Cubedlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// cMaHScroll

cMaHScroll::cMaHScroll()
{
}

cMaHScroll::~cMaHScroll()
{
}


BEGIN_MESSAGE_MAP(cMaHScroll, CScrollBar)
	//{{AFX_MSG_MAP(cMaHScroll)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
	ON_WM_KEYDOWN()
	ON_WM_CHAR()
	ON_WM_KEYUP()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// cMaHScroll message handlers


	//int min,max,pos;
	//float uMin, uMax, uPos;// user

void cMaHScroll::setSB(float umin, float umax, float *upos,
		float usmallC, float ulargeC)
{
	min=0;max=1000;// en millime, coordonnes de la barre

	uMin=umin;
	uMax=umax;
	uPos=upos;
	uSmallC=usmallC;
	uLargeC=ulargeC;

	pos=(int)(min+(max-min)*(*uPos-uMin)/(uMax-uMin));
	smallC=(int)((max-min)*(usmallC)/(uMax-uMin));
	largeC=(int)((max-min)*(ulargeC)/(uMax-uMin));

	SetScrollRange(min,max);
	SetScrollPos(pos);
}

	
void cMaHScroll::onScroll(UINT nSBCode, UINT nPos)
{
    int pos=GetScrollPos();

    switch (nSBCode)
    {
        case SB_LINELEFT:pos-=smallC;break;
        case SB_PAGELEFT:pos-=largeC;break;

		case SB_LINERIGHT:pos+=smallC;break;
        case SB_PAGERIGHT:pos+=largeC;break;

        case SB_THUMBTRACK:
        case SB_THUMBPOSITION:pos=nPos;
    }
    if(pos>max)pos=max;
    if(pos<min)pos=min;

	*uPos=uMin+(uMax-uMin)*((float)(pos-min))/(max-min);

    SetScrollPos(pos);
}


// par dfaut, les flches sont associes avec une scrollbar
// envoyer les caractres du clavier au dialogue principal

void cMaHScroll::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// TODO: Add your message handler code here and/or call default
	CCubeDlg *p=(CCubeDlg*)GetParent();

	// on transfere les messages du clavier au parent
	p->OnKeyUp(nChar, nRepCnt, nFlags);
	return;
	//CScrollBar::OnKeyDown(nChar, nRepCnt, nFlags);
}

void cMaHScroll::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// TODO: Add your message handler code here and/or call default
	return;
	//CScrollBar::OnChar(nChar, nRepCnt, nFlags);
}

void cMaHScroll::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// TODO: Add your message handler code here and/or call default
	return;
	//CScrollBar::OnKeyUp(nChar, nRepCnt, nFlags);
}


	
void cMaHScroll::load(FILE* fp)
{
	float xx;
	fscanf(fp,"%f%f%f%f%f",
		&uMin,&uMax,&xx,&uSmallC,&uLargeC);
	*uPos=xx;
	setSB(uMin,uMax,uPos,uSmallC,uLargeC);
}

void cMaHScroll::save(FILE* fp)
{
	fprintf(fp,"%10.4f %10.4f %10.4f %10.4f %10.4f \r\n",
		uMin,uMax,*uPos,uSmallC,uLargeC);
}

void cMaHScroll::setPosition(float posu)
{
	*uPos=posu;
	int pos=(int)(min+(max-min)*(*uPos-uMin)/(uMax-uMin));
	SetScrollPos(pos);
}


