// cubeDlg.h : header file
//
#pragma once

//----------------------------------
#include "cDrawWin.h"
#include "cMaHScroll.h"
#include "cDiaProprietes.h"

//----------------------------------

class CCubeDlg : public CDialog
{
// Construction
public:
	CCubeDlg(CWnd* pParent = NULL);	// standard constructor

	cDrawWin	m_graphe; 	// fentre de dessin OpenGL
	cDiaProprietes diaProp; // dialogue de proprits

	void saveScrollBars(const char* fn);
	void loadScrollBars(const char* fn);

// Dialog Data
	//{{AFX_DATA(CCubeDlg)
	enum { IDD = IDD_CUBE_DIALOG };
	cMaHScroll	m_sbOuverture;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCubeDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CCubeDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnContextMenu(CWnd* /*pWnd*/, CPoint /*point*/);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	cMaHScroll m_sbRotX;
	cMaHScroll m_sbRotY;
	cMaHScroll m_sbRotZ;
	cMaHScroll m_sbTransX;
	cMaHScroll m_sbTransY;
	cMaHScroll m_sbTransZ;
	afx_msg void OnObjetsprRobot();
	afx_msg void OnObjetsprSavescrollbars();
	afx_msg void OnObjetsprLoadscrollbars();
	afx_msg void OnObjetsprInitialiserlapositiondelasc();
//	virtual BOOL DestroyWindow();
//	afx_msg void OnTimer(UINT nIDEvent);
};

